<?php

require_once('../common/vendor/autoload.php');
require_once('../../core/backend.php');
require_once('../constants.php');

require_once('../common/Api.php');
require_once('../common/Db.php');
require_once('../common/GoogleKMS.php');

require_once('OAuth2.php');
require_once('TokenApi.php');
require_once('PullApi.php');
require_once('RemoveApi.php');
require_once('SignupOrLoginAppleApi.php');
require_once('SignupOrLoginGoogleApi.php');

$httpAuthToken = $savvyext->cfgReadChar('system.oauth2_token');

header("Access-Control-Allow-Origin: *");
header("Access-Control-Expose-Headers: Access-Control-Allow-Origin");
header("Access-Control-Allow-Headers: Cache-Control, Pragma, Origin, Authorization, Content-Type, X-Requested-With, client_id");
header("Access-Control-Allow-Methods: POST, GET, PUT, DELETE, OPTIONS");
header('Content-type: application/json');

if ("OPTIONS" === $_SERVER['REQUEST_METHOD']) {
    exit();
}

$headers = getallheaders();
if ((!isset($headers["Authorization"]) || substr($headers["Authorization"],-strlen($httpAuthToken))!=$httpAuthToken) &&
    (!isset($headers["authorization"]) || substr($headers["authorization"],-strlen($httpAuthToken))!=$httpAuthToken)) {
    header('HTTP/1.1 401 Unauthorized');
    header('Status: 401 Unauthorized');
    echo "{\"status\":\"Missing authorization\"}";
    exit();
}

try {
	if (strpos($_SERVER['REQUEST_URI'],'/api/')===false) {
		throw new Exception("Invalid API request");
	}
	$requestUri = explode('/', trim($_SERVER['REQUEST_URI'],'/'));
	while (array_shift($requestUri) !== 'api') {
	};
	if ($requestUri[0]=='token') {
		$api = new TokenApi($requestUri);
	}
	else if ($requestUri[0]=='pull') {
		$api = new PullApi($requestUri);
	}	
	else if ($requestUri[0]=='remove') {
		$api = new RemoveApi($requestUri);
	}	
	else if ($requestUri[0]=='signuporloginapple') {
		$api = new SignupOrLoginAppleApi($requestUri);
	}
	else if ($requestUri[0]=='signuporlogingoogle') {
		$api = new SignupOrLoginGoogleApi($requestUri);
	}
	else {
		echo json_encode(Array('error' => 'Invalid API request'));
	}
	echo $api->run();
}
catch (Exception $e) {
	echo json_encode(Array('error' => $e->getMessage()));
}

